<?php 
/**
 * Projekt: WS-Reporter
 *          Anzeige der globalen Attribute bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.02.2023 NLS
 *
 */
require_once './includes/wsrTranslate.inc';
global $query, $dwhListe;
?>

<table>
<tr><th><?=WSRTranslate::translate('Name')?></th><th><?=WSRTranslate::translate('Wert')?></th></tr>
<tr><th class="left" ><?=WSRTranslate::translate('Fenster-Titel')?></th>
  <td><input type="text" value="<?=quoteForText($query->outputTitlePrefix)?>" size="40" 
  onchange="setAttrib('outputTitlePrefix',this.value)" autocomplete="off"/> 
</td></tr>
<tr><th class="left" ><?=WSRTranslate::translate('Standard-Überschrift')?></th>
  <td><input type="text" value="<?=quoteForText($query->defaultTitle) ?>" size="40" 
  onchange="setAttrib('defaultTitle',this.value)" autocomplete="off"/> 
</td></tr>
<tr><th class="left" ><?=WSRTranslate::translate('Datenbank')?></th>
  <td>
  <select  onchange="setAttrib('dwh',this.value)">
<?php 
foreach ($dwhListe as $dwh){
    echo '<option value="'.$dwh,'" '.checkSel($dwh,$query->dwh).' >'.$dwh."</option>\n";
}
?>  
</select> 
</td></tr>
<tr><th class="left" ><?=WSRTranslate::translate('physische Tabelle')?></th>
  <td><input type="text" value="<?=$query->phys_table ?>" size="40" 
  onchange="setAttrib('phys_table',this.value)" autocomplete="off"/> 
</td></tr>


<tr><th  class="left" ><?=WSRTranslate::translate('Typ der Quelle')?></th><td>
  <select  onchange="setAttrib('queryType',this.value)">
<?php 
for ($i = 0; $i < 2; $i++){
    echo '<option value="'.$i,'" '.checkSel($i,$query->queryType).' >'.Query::getTypeText($i)."</option>\n";
}
$i = 11; // Dimension
for ($i = 11; $i <= 12; $i++){
    echo '<option value="'.$i,'" '.checkSel($i,$query->queryType).' >'.Query::getTypeText($i)."</option>\n";
}
?>  
</select> 
 </td></tr>

<tr><th  class="left" ><?=WSRTranslate::translate('Historisierung')?></th><td>
  <select  onchange="setAttrib('histType',this.value)">
<?php 
for ($i = 0; $i <= 3; $i++){
    echo '<option value="'.$i,'" '.checkSel($i,$query->histType).' >'.Query::getHistText($i)."</option>\n";
}
?>  
</select> 
 </td></tr>
<?php 
error_log('Glob-Hist-Type = '.$query->histType);
if ($query->histType == Query::VONBIS){
?>
<tr><th  class="left" ><?=WSRTranslate::translate('Intervall-Grenzen')?></th><td>
<b><?=WSRTranslate::translate('von=')?></b> <?php 
if (isValid($query->histAb)) echo $query->histAb;
else echo '<span class="red fett">'.WSRTranslate::translate('fehlt').'</span>'?> 
<b><?=WSRTranslate::translate('bis=')?></b> <?php
if (isValid($query->histBis)) echo $query->histBis;
else echo '<span class="red fett">'.WSRTranslate::translate('fehlt').'</span>'?></td></tr>
<?php
}
if ($query->histType == Query::STICHTAG 
    || $query->histType == Query::STICHTAGE){    
?>
<tr><th  class="left" > <?=WSRTranslate::translate('Stichtag')?></th><td>
<?php 
if (isValid($query->histStichtag)) echo $query->histStichtag;
else echo '<span class="help" title="'.WSRTranslate::translate('Wenn kein Stichtag gesetzt ist,
können in der Report-Definition nur
explizite Datumswerte verwendet werden.').'">'.WSRTranslate::translate('fehlt').'</span>'?>
 </td></tr>
<?php
}else if (isValid($query->histStichtag)){    
    ?>
<tr><th  class="left help" title="<?=WSRTranslate::translate('Bei der von-bis-Historisierung 
kann das Gültigkeitsintervall auf diesen Wert
in den Datensätzen bezogen werden.')?>
<?=WSRTranslate::translate('(Stichtag der Quelle / Basisquelle)')?>" ><?=WSRTranslate::translate('Stichtag')?></th><td>
<?= $query->histStichtag ?> 
 </td></tr>
<?php
}
    
if ($query->histType > 0){
    ?>
<tr><th  class="left help" title="<?=WSRTranslate::translate('Voreinstellung zur Ermittlung des Stichtags für die Basisquelle.')?>"  
><?=WSRTranslate::translate('Ermittlung Stichtag')?></th><td>
  <select  onchange="setAttrib('historyOption',this.value)">
<?php 
for ($i = 0; $i < 7; $i++){
    if (($i == HistoryOptions::HSSTICHTAGSELBST
        || $i == HistoryOptions::HSSTICHTAGBASE)
        && ($query->histType != Query::STICHTAG))
    {
        ?>
<option value='<?= $i ?>' <?=checkSelN($query->historyOption, $i) ?>
class='red' title='<?=WSRTranslate::translate('ACHTUNG: Mehrere Stichtage führen zu Doppel-Zählungen,
wenn der Stichtag keine Zeile oder Spalte im Report ist.')?>'><?=HistoryOptions::getKlartext($i) ?> *??</option>
<?php 
      }else{    
           echo '<option value="'.$i,'" '.checkSelN($i,$query->historyOption).' >'.HistoryOptions::getKlartext($i)."</option>\n";
      }
}
if ($query->historyOption == HistoryOptions::HSDATUM && isValid($query->historyDate))
    $hDatum =  WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d',$query->historyDate));
    else $hDatum = '';
    
?>  

</select> 
<span id='HistDate' <?php if ($query->historyOption != 6) echo 'class="hidden"' ?>><?=WSRTranslate::translate('Datum')?>: 
<input onchange="setAttrib('historyDate',this.value)" size="13" value="<?=$hDatum ?>" /></span>            


</td></tr>
<?php
}

if ($query->queryType < 10){

?>
<tr><th class='left'><?=WSRTranslate::translate('Werte-Auswahl')?></th>
<td>
<input type="checkbox" onclick="setAttrib('hatWerteAuswahl',this.checked);"  <?=checked($query->hatWerteAuswahl)?> 
	/>&nbsp;<?=WSRTranslate::translate('aktivieren')?>
<?php
if ($query->hatWerteAuswahl){
?>
<input type="button" value='<?=WSRTranslate::translate('Auswahl eingeben')?>' onclick="enterValueList()" /></td>
<?php
}
?>
</tr>
<?php 
}
?> 
<tr><th class='left'><?=WSRTranslate::translate('Sprache')?></th>
<td>
<?=qTranslate::sprache($query->qLanguage)?>
&nbsp;&nbsp;&nbsp;<?=WSRTranslate::translate('Übersetzungen')?>:
<?php
foreach ( qTranslate::SPRACHEN as $l)
    if ($l != $query->qLanguage){
    $check = '';
    if (false !== array_search($l, $query->qTranslations)) $check = 'checked';
?>
<input type="checkbox" <?=$check ?> onchange="setAttrib('translation_<?=$l ?>',this.checked)" /> 
<?= qTranslate::sprache($l) ?>
<?php 
}
?>
</td></tr>
<tr><th class="left" ><?=WSRTranslate::translate('Beschreibung')?></th>
  <td>
  <textarea rows="5" cols="60" autocomplete="off" onchange="setAttrib('table_description',this.value)"
  ><?=quoteForText($query->table_description) ?>
</textarea>
</td></tr>
<tr><th class="left" ><?=WSRTranslate::translate('Technische Hinweise')?></th>
  <td>
  <textarea rows="5" cols="60" autocomplete="off" onchange="setAttrib('table_hints',this.value)"
  ><?=quoteForText($query->table_hints) ?>
</textarea>
</td></tr>
<tr><th class="left" ><?=WSRTranslate::translate('projektspezifisches CSS-Sheet')?></th>
  <td><input type="text" value="<?=$query->reportCSS ?>" size="30" 
  onchange="setAttrib('reportCSS',this.value)" autocomplete="off"/> 
  <?=WSRTranslate::translate('Hover')?>: <select onchange="setAttrib('reportHoverMode',this.value)">
<option value="0" <?=checkSel(0,$query->reportHoverMode)?>>-</option>  
<option value="1" <?=checkSel(1,$query->reportHoverMode)?>><?=WSRTranslate::translate('Zellen')?></option>  
<option value="2" <?=checkSel(2,$query->reportHoverMode)?>><?=WSRTranslate::translate('Zeilen')?></option>  
<option value="3" <?=checkSel(3,$query->reportHoverMode)?>><?=WSRTranslate::translate('Zellen und Zeilen')?></option>  
  </select>
  
</td></tr>
<tr><th class="left" ><?=WSRTranslate::translate('Tabelle mit Muster-Var.')?></th>
  <td><input type="text" value="<?=$query->muster_tabelle ?>" size="40" 
  		onchange="setAttrib('muster_tabelle',this.value)" autocomplete="off"/> 
</td></tr>

</table>
