<?php
/**
 * Projekt: WS-Reporter
 *          Anzeige der Metadaten zu Berechnungen mit verknüpften Daten bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:   22.02.2023 MS
 *
 */
require_once './includes/classes.inc';
require_once './includes/wsrTranslate.inc';

if (false){
    $query = new Query("d");
    $jq = new Query("d");
    $mr = new MetaRecord();
    $aq = new AddedQuery("d");
}
if ($query->qEditSubject < 100) {
    echo "Fehler EditSubject = ".$query->qEditSubject;
        return;
}
    $aq = $query->addQueries->getPos($query->qEditSubject - 100);
    $jq = $aq->getQuery();
    $cv = $aq->calcVars;
 
    ?>
 <h3><?=WSRTranslate::translateH('Zusatz-Variablen für')?> <?=$jq->class_table ?>
 <div class="xButton" onclick="closeQueryEditor()" title="<?=WSRTranslate::translate('schließen')?>">&otimes;</div>
 <div class="gBox" >
 <input type="checkbox"  onclick="hideShowAll('jm',this.checked)" title="<?=WSRTranslate::translate('alles ein- oder ausblenden')?>" /></div>
 </h3> 
 <table>
 <?php
 
 for ($i = 0; $i < count($cv); $i++){
	 
	 $v = $cv[$i];
	 /**
	  * @var MetaRecord $mr
	  */
	 $mr = $jq->metaData[$v];
	 if ($mr == null) echo "<?=WSRTranslate::translate('Fehler: keine Metadaten für')?> $v<br>";
	 
 ?>
<tr  ><td colspan="2" style="padding: 0">
<table class="innerTable" > 
<thead> 
<tr class="draggable" 
<?php dragNDdrop(100,$i,'drop')?>><th><?=WSRTranslate::translateH('Name')?></th><th><?=$v ?></th>
<td onclick="moveUp(100,<?=$i ?>)" class="center"><?=iconUp() ?></td>
<td onclick="moveDown(100,<?=$i ?>)" class="center"><?=iconDown() ?></td>
<td onclick="delVar(100,<?=$i ?>)" class="center"><?=iconDelete() ?></td>
 </tr> 
 <tr><th class="left help"
 title="<?=WSRTranslate::translate('Sonderzeichen')?>:
 &amp;sum = &sum;
 &amp;Oslash = &Oslash;
 &amp;uArr = &uArr;
 &amp;dArr = &dArr;
 &amp;permil = &permil;
 &amp;otimes = &otimes;
 "><?=WSRTranslate::translateH('Label')?></th><td colspan="4">
 <input type="text" value="<?=quoteForText($mr->label) ?>" size="45" 
 	onchange="setJoinedQuery(<?=$i ?>,'label',this.value)" autocomplete="off"/>
 	<input type="checkbox"  onclick="hideShow('jm<?=$i ?>',this.checked)" title="Anzeige ein- oder ausblenden" />
 </td></tr>
 </thead>
<tbody class="hideShow"  id="jm<?=$i ?>">  
 <tr><th class="left help" title="<?=WSRTranslate::translate('Sonderzeichen')?>:
 &amp;sum = &sum;
 &amp;Oslash = &Oslash;
 &amp;uArr = &uArr;
 &amp;dArr = &dArr;
 &amp;permil = &permil;
 &amp;otimes = &otimes;
 "><?=WSRTranslate::translateH('Beschreibung')?></th><td colspan="4">
 <textarea rows="5" cols="60" autocomplete="off" name="description" 
 onchange="setJoinedQuery(<?=$i ?>,'description',this.value)"
><?=quoteForText($mr->description) ?>
</textarea></td></tr> 
 <tr><th class="left help" ><?=WSRTranslate::translateH('Technische Hinweise')?></th><td colspan="4">
 <textarea rows="5" cols="60" autocomplete="off" name="description" 
 onchange="setJoinedQuery(<?=$i ?>,'hints',this.value)"
><?=quoteForText($mr->hints) ?>
</textarea></td></tr> 
 <tr><th class="help left" 
 title="<?=WSRTranslate::translate('Ganze Zahlen erhalten keine Tausender-Punkte.
 Ganze Zahlen mit Tausender-Punkten sind Dezimalzahlen
 ohne Nachkommastellen.')?>"><?=WSRTranslate::translateH('Typ')?></th><td colspan="4" class="nowrap">
   <select name="type" onchange="setJoinedQuery(<?=$i ?>,'type',this.value)">
<?php 
foreach (MetaRecord::klartextType as $type => $text){
    if ($type < 20 && $type != MetaRecord::WEBLINK)
        echo '<option value="'.$type.'" '.checkSel($type,$mr->type).' >'.$text."</option>\n";
}
echo "</select>\n";

 if (MetaRecord::DECIMAL == $mr->type || MetaRecord::GELD == $mr->type){
 ?>
 <?=WSRTranslate::translateH('Nachkommast')?>.:
 <input type="number" value="<?=$mr->decimals ?>" size="3"   
   onchange="setJoinedQuery(<?=$i ?>,'decimals',this.value)" autocomplete="off" />
<?php
 }
?>
  <select name="align" onchange="setJoinedQuery(<?=$i ?>,'align',this.value)">
 <option value="left" <?=checkSel("left",$mr->align) ?>><?=WSRTranslate::translate('links')?></option>
 <option value="right" <?=checkSel("right",$mr->align) ?>><?=WSRTranslate::translate('rechts')?></option>
 <option value="center" <?=checkSel("center",$mr->align) ?>><?=WSRTranslate::translate('zentriert')?></option>
</select> 
 </td></tr> 
 
 <tr><th class="left"><?=WSRTranslate::translateH('Filter-Typ')?>:</th><td colspan="4">
  <select name="filterType" onchange="setJoinedQuery(<?=$i ?>,'filterType',this.value);setFilterAnzeige()" >
 <option value="<?=MetaRecord::NONE ?>" 
        <?=checkSel(MetaRecord::NONE,$mr->filterType) ?>><?=WSRTranslate::translate('kein Filter')?></option>
 <option value="<?=MetaRecord::VON_BIS ?>" 
        <?=checkSel(MetaRecord::VON_BIS,$mr->filterType) ?>><?=WSRTranslate::translate('von bis')?></option>
 </select> 
 </td></tr>
 
 <tr><th class="help left"	title="<?=WSRTranslate::translate('ACHTUNG: hier müssen die Spalten aus den Datenquellen verwendet werden!
 Beispiele: base.wp_wertd und join.wp_wertd, es geht auch base.kursgewinn.
 base. und join. bezeichnen die Quelle.
 Namen der physischen Tabellen sind nicht zulässig.')?>
 <?=WSRTranslate::translate('Tipps: 
 ifnull(join.wert,0) verwenden, wenn mit NULL-Werten als 0 gerechnet werden soll.
 if(bool,wert1,wert2) ist Alternative zu case when bool then wert1 else wert2 end.')?>"
 	 ><?=WSRTranslate::translateH('Ermittlung')?></th><td colspan="4">
 <textarea rows="2" cols="60" autocomplete="off" onchange="setJoinedQuery(<?=$i ?>,'selectVar',this.value)"
  ><?=quoteForText(blankAsNull($mr->selectVar)) ?>
</textarea> 	 
<!-- 
 <input type="text" value="<?=quoteForText($mr->selectVar) ?>" size="45"
 		onchange="setJoinedQuery(<?=$i ?>,'selectVar',this.value)" autocomplete="off"/>
 -->
 </td></tr> 
 <?php 
 if (isValid($mr->displayVar)){
 ?>
 <tr><th class="help left" title="Dieses Feld muss immer leer sein.
 Es wird hier nur noch angezeigt, um alte Einträge
 korrigieren zu können.">Ergebnis-Var.</th><td colspan="4">
 <input type="text" value="<?=$mr->displayVar ?>" size="45"
 		onchange="setJoinedQuery(<?=$i ?>,'displayVar',this.value)" autocomplete="off"/>
 </td></tr>
 <?php }?>
  <tr><th class="left"><?=WSRTranslate::translateH('Chart-Farbe')?>:</th>
  <td colspan="4" class="nowrap">
  <input type="text" onchange="setJoinedQuery(<?=$i ?>,'chartColor',this.value)" value="<?=$mr->chartColor ?>" 
  size="10"   autocomplete="off" /> <?=WSRTranslate::translateH('wenn negativ')?>: 
  <input type="text"  onchange="setJoinedQuery(<?=$i ?>,'chartNegColor',this.value)" 
  value="<?=$mr->chartNegColor ?>" size="10"   autocomplete="off" /></td></tr>
 <tr><th class="left"><?=WSRTranslate::translateH('Chart-Gruppe')?>:</th>
  <td colspan="4" class="nowrap">
  <input type="text"  onchange="setJoinedQuery(<?=$i ?>,'chartGroup',this.value)" 
  value="<?=blankAsNull($mr->chartGroup) ?>" size="30"   autocomplete="off" /></td></tr>
<tr><td class='help' title="<?=WSRTranslate::translate('Optionale Unter- und Obergrenzen,
 damit Extremwerte die Charts für Normalfälle
 nicht unbrauchbar machen.')?>" 
 ><?=WSRTranslate::translateH('Chart-Skalierung')?>:</td><td><?=WSRTranslate::translateH('Untergrenze')?>:
 <input type="text" name="chartMin" value="<?=blankAsNull($mr->chartMin) ?>" size="8"   autocomplete="off"
 onchange="setJoinedQuery(<?=$i ?>,'chartMin',this.value)" />
 <?=WSRTranslate::translateH('Obergrenze')?>:
 <input type="text" name="chartMax" value="<?=blankAsNull($mr->chartMax) ?>" size="8"   autocomplete="off"
 onchange="setJoinedQuery(<?=$i ?>,'chartMax',this.value)" /></td></tr> 
 <tr><th></th><td colspan="4" class="nowrap" class="center">
   <button onclick="saveJoinMuster('<?=$v ?>')"><?=WSRTranslate::translate('Als Muster speichern')?></button> 
  <button onclick="loadJoinMuster('<?=$v ?>',<?=$i ?>)"><?=WSRTranslate::translate('Muster laden')?></button> 
</td></tr>
 <tr><th colspan="5" class="gray">&nbsp;</th></tr>
 </tbody></table></td></tr>
<?php
 }
?> 
<tfoot>
  <tr><th><?=WSRTranslate::translateH('Neue Variable')?></th><td colspan="1"> 
 <input type="text" value="" id="NV100" autocomplete="off" onchange="newVar(100,this)"/>
 </td>
 </tfoot>
 </table>
 <?php
 if ($query->showMuster == 100){
     $liste = $query->listMuster();
     echo 'Muster (ggf. anklicken):<br><table>';
     foreach ($liste as $name => $label)
     if (! isset($jq->metaData[$name])){
         ?>
<tr <?=makeTitle($label[1])?>><th class="left" onclick="newMusterVar(100,'<?=$name ?>')"><?=$name ?></th>
<td onclick="newMusterVar(1,'<?=$name ?>')"><?=$label[0] ?></td></tr>
	 <?php
	 }
	 ?>
 
	 <tr><th></th>
	 <th onclick="closeMuster(100)" ><?=WSRTranslate::translate('schließen')?></th></tr>
	 </table>	 
 	 <?php
 }
	 
?>
 <div class="center">
 <?php
 /*
  <button onclick="submitQueryEditorForm('close')">Speichern und Schließen</button> 
  <button onclick="submitQueryEditorForm('refresh')">Speichern ohne Schließen</button>
  */
  ?>
  <button onclick="closeQueryEditor()"><?=WSRTranslate::translate('Schließen')?></button> 
 </div>
 <br><br><br>
 