<?php
/**
 * Projekt: WS-Reporter
 *          Testen der einzelnen Elemente einer Datenquelle
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.02.2023 MS
 * 
 * Im Unterschied zu eqpTest wird hier die Sql aus den Metarecords 
 * nacheinander getestet, damit der Fehler lokalisiert wird.
 *
 */

require_once './phpsec/createDBH.inc';
require_once './includes/eqTest.inc';
require_once './includes/wsrTranslate.inc';

global $query,  $testMode, $sql;
$ergebnis = true;

foreach ($query->metaData as $mr){
    if (false) $mr = new MetaRecord();
    if ($mr->filterType == MetaRecord::WERTELISTE) continue;
    if ($mr->filterType == MetaRecord::WINDOWFILTER) continue;
    if ($mr->baseFilter()) continue;
    $erg = true;
    if ($mr->filterType == MetaRecord::SONDERFILTERSEL){
        $options = $mr->getSelectOptions();
        foreach ($options as $opt){
            if (!testWhere($opt[1])){
                $erg = false;
                echo "\n ".WSRTranslate::translate('bei Auswahl').' '.$opt[0]."\n";
            }
        }
        if (isValid($mr->selectVar) && !testSelect($mr->selectVar)){
            $erg = false;
            echo "\n";
        }
        if (isValid($mr->displayVar) && !testSelect($mr->displayVar)){
            $erg = false;
            echo "\n";
        }
        if (!$erg){
            $ergebnis = false;
            echo WSRTranslate::translate('im Sonderfilter').' '.$mr->getName()."\n";
        }
        continue;
    }
    if (isValid($mr->selectVar) && !testSelect($mr->selectVar)){
        $erg = false;
        echo "\n";
    }
    if (isValid($mr->displayVar) && !testSelect($mr->displayVar)){
        $erg = false;
        echo "\n";
    }
    if (!$erg){
        $ergebnis = false;
        echo WSRTranslate::translate('bei').' '.$mr->getName()."\n";
    }
}

for ($qi=0; $qi < $query->addQueries->size(); $qi++){
    $aq = $query->addQueries->getPos($qi);
    if (false) $aq = new AddedQuery('');
    error_log('Teste '.$aq->class_table);
    foreach ($aq->calcVars as $v){
        if (!testJoinSelect($v,$aq)){
            $ergebnis = false;
            echo "\n".WSRTranslate::translate('bei Berechnung').' '.$aq->class_table.':'.$v."\n\n";
        }
    }
}
if ($ergebnis) echo WSRTranslate::translate('Test bestanden');

    