<?php
/**
 * Projekt: WS-Reporter
 *          Muster-Variable laden und speichern bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 */

if ($query->qEditSubject <= 0 
    || ! (isValid($query->qEditVar) || isset($_REQUEST['varName']) ) ){
    http_response_code(425);
    echo "setMetaAttrib: Ungültiger Aufruf \nqEditSubject=$query->qEditSubject qEditVar=$query->qEditVar";
    return;
}
if (false) $metaRecord = new MetaRecord();
if ($query->qEditSubject >= 100){
    $metaRecord = $query->addQueries->getPos($query->qEditSubject -100)->getQuery()->metaData[$_REQUEST['varName']];
    $query->qEditVar = $_REQUEST['varName']; 
    $editSubject = 100;
    
}else{
    $metaRecord = $query->metaData[$query->qEditVar];
    $editSubject = $query->qEditSubject;
}
if ($metaRecord == null){
    http_response_code(425);
    echo "setMetaAttrib: Keine Metadaten für $query->qEditVar";
    return;
}
$action = $_REQUEST['action'];

require_once './phpsec/createDBH.inc';
$action = $_REQUEST['action'];
if (0 == strcmp($action,'load')) { // SQL-INJECTION
    $sql = new SqlAbfrage('WSR');
    $sql->sql = 'select * from queryColumnMetadata ';
    $sql->addSel('table_name =', $query->muster_tabelle);
    if ($editSubject == 100) {
        $sql->addSel('column_name like ', '_:'.$query->qEditVar);
        $sql->addSel('SpaltenTyp >=',$editSubject);
    }
    else {
        $sql->addSel('column_name =', $query->qEditVar);
        $sql->addSel('SpaltenTyp =',$editSubject);
    }
    $stmt = $sql->execute();
//    error_log(print_r($sql,true));
    if ($stmt === false) return;
    if ($z = $stmt->fetchObject()){
        $metaRecord = new MetaRecord();        
        $metaRecord->fillFrom($z,$query);
        $metaRecord->getSelectOptions();
        $oldMetaRecord = $query->getReportMetaRecord($query->qEditVar);
        if ($oldMetaRecord != null){
//            error_log('Dimension aus '.$oldMetaRecord->getName());
            // Dimensions-Parameter übernehmen
            if ($metaRecord->dimNr != $oldMetaRecord->dimNr){
                if ($oldMetaRecord->dimNr >0) $new = 'd'.$oldMetaRecord->dimNr.'.';
                else $new = 'base.';                
                if ($metaRecord->dimNr >0) $old = 'd'.$metaRecord->dimNr.'.';
                else $old = 'base.';
                
                $metaRecord->selectVar = str_replace($old,$new,$metaRecord->selectVar); 
                $metaRecord->displayVar = str_replace($old,$new,$metaRecord->displayVar);
                
            }
            $metaRecord->dimNr = $oldMetaRecord->dimNr;
            $metaRecord->reqDim = $oldMetaRecord->reqDim;
        }
        else
        if ($metaRecord->dimNr > 0){
            // Dimensionen passen in der Regel nicht und können deshalb auch
            // nicht übernommen werden
//            error_log('Dimension für '.$metaRecord->getName().' zurücksetzen.');
            $metaRecord->dimNr = -1;
            $metaRecord->reqDim = array();
        }else{
//            error_log('Nichts gemacht für '.$metaRecord->getName());
        }
        
        if ($query->qEditSubject >= 100){
            $metaRecord->setTable($query->addQueries->getPos($query->qEditSubject -100)->getQuery()->class_table);
            $query->qEditVar = "";
            $query->addQueries->getPos($query->qEditSubject -100)->getQuery()->metaData[$_REQUEST['varName']] = $metaRecord;
        }else{
            $metaRecord->setTable($query->class_table);
            $query->metaData[$query->qEditVar] = $metaRecord;
        }
        return;
    }
    http_response_code(425);
    echo 'Muster Variable '.$query->qEditVar.' nicht gefunden. '.$editSubject;
    return;    
}
        
if (0 == strcmp($action,"save")) { /* */    
    if ($erg=$metaRecord->saveForTable($query->muster_tabelle,$editSubject)){    
            echo $query->qEditVar." als Muster\nin Tabelle ".$query->muster_tabelle." gespeichert.";
            if ($query->qEditSubject >= 100) $query->qEditVar = "";
            return ;
        }
    http_response_code(425);
    echo var_dump($dbh->errorInfo());
    return;
}
        
http_response_code(425);
echo "unbültiger Aufruf:\n".var_dump($_REQUEST);
return;
