<?php
/**
 * Projekt: WS-Reporter
 *          Einlesen der Optionen in die Auswahlliste eines Filters bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 */

require_once './includes/eqTest.inc';

if (false) $query= new Query("Dummy");
if (!isValid($query->qEditVar)){
    http_response_code(425);
    echo "Ungültiger Aufruf qEditVar = $query->qEditVar\n";
    echo var_dump($_REQUEST);
    return;
}

$column_name = $query->qEditVar;
$mr = $query->metaData[$column_name];
if ($mr == null){
    http_response_code(425);
    echo "Ungültiger Aufruf keine Metadaten für qEditVar = $query->qEditVar\n";
    echo var_dump($_REQUEST);
    return;
}
if (false) $mr = new MetaRecord();

if (isset($_REQUEST['read'])){
    global $dbDWH;
    require_once './phpsec/createDBH.inc';
    if ($dbDWH == null) setdbDWH();
    
    $sql = 'select distinct '.$mr->getSelectVar().' as val, '.$mr->getDisplayVar()." as label\n from "
        .$query->phys_table."\n";
        if (isset($_REQUEST['sort']) && 0 == strcasecmp($_REQUEST['sort'], 'label') )
            $sql .= ' order by '.$mr->getDisplayVar().', '.$mr->getSelectVar();
        else $sql .= ' order by '.$mr->getSelectVar().', '.$mr->getDisplayVar();
        
    if (!( $stmt = $dbDWH->query($sql))){
        http_response_code(425);
        echo "setSelectOptions Feler beim Einlesen\n";
        echo $sql;
        echo var_dump($dbDWH->errorInfo());
    return;     
    }
    while($z = $stmt->fetchObject()){
        $selections[] = array ($z->val, $z->label );              
    }    
    if (count($selections) > 150){
        http_response_code(425);
        echo 'Anzahl der Optionen ist zu groß: '.count($selections);
        echo ('Maximal 150 Optionen erlaubt.');
        return;
    }
    $mr->setSelectOptions($selections);
    return;
}
if (! isset($_REQUEST['size'])){
    $mr->setSelectOptions(null);    
    return;
}else{
    $selections = array();
    for ($i = 0; $i < $_REQUEST['size']; $i++){
        $selections[] = array ($_REQUEST['V'.$i], $_REQUEST['L'.$i] );   
        if ($mr->filterType == MetaRecord::SONDERFILTERSEL) 
            if (! testWhere($_REQUEST['L'.$i])) echo 'bei '.$_REQUEST['V'.$i]."\n";
    }
    $mr->setSelectOptions($selections);
//    $query->metaData[$column_name] = $mr;
    return;
}


http_response_code(425);
echo "setSelectOptions ist noch nicht fertig\n";
echo var_dump($_REQUEST);
return;