<?php
/**
 * Projekt: WS-Reporter
 *          Befehle für den Report-Editor
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    4.11.2021
 *
 */
global $sqlErg, $query;
if ($_REQUEST['action'] == "deleteReport"){
    if (!dqAdminRechte()){
        http_response_code(425);
        echo "Für diese Operation sind die Administrator-Rechte \nfür die Datenquelle {$query->class_table} erforderlich";
        die;
    }
    require_once './phpsec/createDBH.inc';
    if (!isset($_REQUEST['reportID']) || $_REQUEST['reportID'] <= 0){
        http_response_code(425);
        echo 'ungültige ReportID';
        die();        
    }
    $tables = array('reportAttributes', 'reportAddFilters', 'reportAddFilterLists',
        'reportFilters', 'reportFilterLists', 'reportColumns', 'reportRows', 'reportValues',
        'reportComment', 'reportJoinedTables', 'reportReports', 'reportTitle'      
    );
    foreach ($tables as $t){
        $sql = new SqlAbfrage('WSR');
        $sql->sql = "delete from ".$t;
        $sql->addSel('reportID =', $_REQUEST['reportID']);
        $erg = $sql->execute();
        if ($erg === false){
            echo "Fehler im Statement beim Löschen:\n".$sql->errorInfo()[2]."\n".$sql->sql;
            return;
        }
    }
    return;
}
if ($_REQUEST['action'] == "saveReport"){
    if (!dqAdminRechte()){
        http_response_code(425);
        echo "Für diese Operation sind die Administrator-Rechte \nfür die Datenquelle {$query->class_table} erforderlich";
        die;
    }
    require './includes/saveReportDef.inc';
    return;
}
if ($_REQUEST['action'] == "addVar"){
    if (isset($_REQUEST['tab'])){
        switch ($_REQUEST['tab']){
            case 'Zeilen':
                if ($_REQUEST['action'] == 'addVar'){
                    $vName = $_REQUEST['var'];
//                     error_log('Erzeuge Spalte '.$vName);
                    // zusätzliche Web-Link-Spalte
                    if ($vName == '*webLinkColumn'){
                        for ($i=0;$i < $query->repRows->size();$i++){
                            if (! $query->repRows->has('#webLink'.$i)) $vn = '#webLink'.$i;
                        }                            
                        $v = new RepRow($vn);
                        $v->webLinkColumn = true;
                        $v->web_link_title = 'Link';
                        $v->web_link_value = 'X';   
//                        error_log('Erzeuge Web-Link-Spalte');
                    }else $v = new RepRow($_REQUEST['var']);
                    $query->repRows ->put($v);
                    return;
                }
                break;
            case 'Spalten':
                if ($_REQUEST['action'] == 'addVar'){
                    $n = $_REQUEST['var'];
                    $v = new RepColumn($n);
                    if (array_key_exists($n,$query->metaData)){
                        $v->label = $query->metaData[$n] ->label;
                    }
                    $c = 0;
                    while ($query->repColumns->has($v->column_name)){
                        $v->column_name = $n.'|'.$c;
                        $c++;
                    }
                    $query->repColumns->put($v);                    
                    return;
                }
                break;
            case 'Werte':
                if ($_REQUEST['action'] == 'addVar'){
                    $v = new RepValue($_REQUEST['var']);
                    $query->repValues ->put($v);
                    return;
                }
                break;
            case 'Filter':
                if ($_REQUEST['action'] == 'addVar'){
                    if ($_REQUEST['var'] == '*windowFilter'){
                        for ($i=0; $query->repFilter->has('#windowFilter'.$i) ;$i++);
                        $vn = '#windowFilter'.$i;
                        $v = new WindowFilter($vn);
                        //                        error_log('Erzeuge Web-Link-Spalte');
                    }else $v = new RepFilter($_REQUEST['var']);
                    $query->repFilter ->put($v);
                    return;
                }
                break;
            case 'AddFilter':
                if ($_REQUEST['action'] == 'addVar'){
                    $v = new RepFilter($_REQUEST['var']);
                    if ($query->repFilter->has($_REQUEST['var'])){
                        $f = $query->repFilter->get($_REQUEST['var']);
                        $v->abSpalte = $f->abSpalte;
                        $v->inTitelZeile = $f->inTitelZeile;
                        $v->selectorImOutput = $f->selectorImOutput;
                        $v->reportCopyFilter = $f->reportCopyFilter;
                        $v->doNotTake = $f->doNotTake;                        
                    }
                    $query->addFilter ->put($v);
                    return;
                }
                break;
            case 'ReportVerweise':
                if ($_REQUEST['action'] == 'addVar'){
                    $v = $_REQUEST['var'];
                    if(strpos($v, "?") !== FALSE){
                        require_once './phpsec/createDBH.inc';
                        $query->showMuster = 203;
                        $sql = new SqlAbfrage('WSR');
                        $sql->sql = 'select Report, Report_Kommentar, DatenQuelle from reportVerzeichnis';
                        $sql->addSel("Report like ", str_replace('?', '%', trim($v)));
                        $sql->sql.= ' order by Report';
                        $stmt = $sql->execute();
                        if ($stmt == false){
                            die();
                        }
                        $query->musterListe = array();
                        while ($z = $stmt->fetchObject()) {
                            $t = array();
                            $t[0] = $z->Report;
                            $t[1] = $z->DatenQuelle."\n".$z->Report_Kommentar;;
                            $query->musterListe[$z->Report] = $t;
                        }
                        return;
                    }
                    $v = new RepReport($_REQUEST['var']);
                    $query->repReports ->put($v);
                    if ( $query->showMuster == 203){
                        unset($query->musterListe[$v]);
                    }
                    return;
                }
                break;
        }
    }    
}


http_response_code(425);
echo "Ungültiger Aufruf\n".var_dump($_REQUEST);