<?php
/**
 * Projekt: WS-Reporter
 *          Reportdefinition aus Datei importieren
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    23.2.2023
 *
 */
require_once './includes/classes.inc';
require_once './includes/funktionen.inc';
require_once './includes/loadClassDef.inc';

function importReportDef($datei){
global $query, $importFileName, $meldungen;
// adminRechteVerlangen();

$query = new Query(null);

$query = null;
$var = null;
$start = false;
$fertig = false;
$iz = 0;
while (($zeile = fgets($datei)) !== false && ! $fertig) {
    $zeile = trim($zeile);
    if ($zeile == "<WS-Report Report Version 1.0>") $start = true;
//    else if (strpos($zeile,"<class>") === 0) ; // nichts machen
    else if ($start){
        if (strpos($zeile,"<classTable>") === 0){
            $query = new Query(substr($zeile, strlen("<classTable>")));
            if (!dqAdminRechte()){
                http_response_code(425);
                echo "Für diese Operation sind die Administrator-Rechte \nfür die Datenquelle {$query->class_table}erforderlich";
                die;
            }
            if ($query != null) {
                 loadClassDef($query);
                 $query->newReport();     
                 $query->reportImported = true;
                }
            else $meldungen.= "Datenquelle ".substr($zeile, strlen("<classTable>"))."konnte nicht erstellt werden.<br>\n";
        }
        
        else if ($query != null){
            if (strpos($zeile,"<reportTitle>") === 0) $query->title  = substr($zeile, strlen("<reportTitle>"));
            // Übersetzungen
            if (strpos($zeile,"<reportTitle_de>") === 0) $query->title_de  = substr($zeile, strlen("<reportTitle_de>"));
            if (strpos($zeile,"<reportTitle_en>") === 0) $query->title_en  = substr($zeile, strlen("<reportTitle_en>"));
            if (strpos($zeile,"<reportTitle_fr>") === 0) $query->title_fr  = substr($zeile, strlen("<reportTitle_fr>"));
            
            if (strpos($zeile,"<userStored>") === 0) $query->importUserCreated = substr($zeile, strlen("<userStored>"));
            if (strpos($zeile,"<timeStored>") === 0) $query->importTimeCreated = substr($zeile, strlen("<timeStored>"));
            if (strpos($zeile,"<userReleased>") === 0) $query->importUserReleased = substr($zeile, strlen("<userReleased>"));
            if (strpos($zeile,"<timeReleased>") === 0) $query->importTimeReleased = substr($zeile, strlen("<timeReleased>"));
            
            if (strpos($zeile,"<sortMode>") === 0) $query->sort_mode  = substr($zeile, strlen("<sortMode>"));
            if (strpos($zeile,"<repFolderMode>") === 0) $query->folderMode  = (int) substr($zeile, strlen("<repFolderMode>"));
            if (strpos($zeile,"<repValueColumnFolderMode>") === 0) $query->valueColumnFolderMode  = substr($zeile, strlen("<repValueColumnFolderMode>"));
            if (strpos($zeile,"<chartSize>") === 0) $query->chart_size  = substr($zeile, strlen("<chartSize>"));
            if (strpos($zeile,"<displayCharts>") === 0) $query->display_charts  = substr($zeile, strlen("<displayCharts>"));
            if ($zeile == "<fixierte Label>") $query->fix_labelColumns = true;
            if ($zeile == "<drop Summen>") $query->dropSummen = true;
            if ($zeile == "<Werte in Spalten>") $query->values_in_columns = true;
            if (strpos($zeile,"<repGeldFaktor>") === 0) $query->repGeldFaktor  = 1.0*substr($zeile, strlen("<repGeldFaktor>"));    
            if (strpos($zeile,"<histOption>") === 0) $query->historyOption  = 1 * substr($zeile, strlen("<histOption>"));
            if (strpos($zeile,"<histDate>") === 0) $query->historyDate  = substr($zeile, strlen("<histDate>"));
            
            if (strpos($zeile,"<dimHistOption>") === 0) {
                $values  = explode('.', substr($zeile, strlen("<dimHistOption>")));
                $query->dimensions[1 * $values[0]]->historyOption = 1 * $values[1];
            }
            if (strpos($zeile,"<dimHistDate>") === 0) {
                $values  = explode('.', substr($zeile, strlen("<dimHistDate>")));
                $query->dimensions[1*$values[0]]->historyDate = $values[1];
            }
            
            if (strpos($zeile,"<rLanguage>") === 0) $query->rLanguage = substr($zeile, strlen("<rLanguage>"));
            if (strpos($zeile,"<rTranslations>") === 0) {
                $query->rTranslations  = explode(' ', substr($zeile, strlen("<rTranslations>")));
            }
            
            
            if (strpos($zeile,"<repRow>") === 0) $var = new RepRow(substr($zeile, strlen("<repRow>"))); 
            if (strpos($zeile,"<repRowSort>") === 0) $var->sort  = (int) substr($zeile, strlen("<repRowSort>"));
            if (strpos($zeile,"<repRowWebLink>") === 0) $var->web_link  = substr($zeile, strlen("<repRowWebLink>"));
            if (strpos($zeile,"<repRowWebLinkTitle>") === 0) $var->web_title = substr($zeile, strlen("<repRowWebLinkTitle>"));
            if (strpos($zeile,"<repRowWebLinkTarget>") === 0) $var->web_target = substr($zeile, strlen("<repRowWebLinkTarget>"));
            if ($zeile == "<repRowWebLinkColumn>") $var->webLinkColumn = true;
            if (strpos($zeile,"<repRowWebLinkTitle>") === 0) $var->web_link_title = substr($zeile, strlen("<repRowWebLinkTitle>"));
            if (strpos($zeile,"<repRowWebLinkValue>") === 0) $var->web_link_value = substr($zeile, strlen("<repRowWebLinkValue>"));
            
            if ($zeile == "<repRowSummenzeile>") $var->summenZeilen = true;
            if ($zeile == "<repRowCopyFilter>") $var->webCopyFilter = true;
            if ($zeile == "<repRowFixierteLabelspalte>") $var->fixedTableColumns = true;
            
            if ($zeile == "</repRow>") {
                $query->repRows->put($var);
                $var = null;
            }
            
            if (strpos($zeile,"<repValue>") === 0) $var = new RepValue(substr($zeile, strlen("<repValue>")));
            if (strpos($zeile,"<repValueLabel>") === 0) $var->label  = substr($zeile, strlen("<repValueLabel>"));
            if (strpos($zeile,"<repValueBackgroundColor>") === 0) $var->backgroundColor  = substr($zeile, strlen("<repValueBackgroundColor>"));
            if (strpos($zeile,"<repValueDisp>") === 0) $var->dispVal  = substr($zeile, strlen("<repValueDisp>"));
            if (strpos($zeile,"<repValueChartScale>") === 0) $var->skalierung  =  1 * substr($zeile, strlen("<repValueChartScale>"));
            if ($zeile == "<repValueKeineSummen>") $var->keineSummen = true;
            if (strpos($zeile,"<repValueCalcBase>") === 0) $var->base  =  substr($zeile, strlen("<repValueCalcBase>"));

            if (strpos($zeile,"<repValueFunction>") === 0) $var->function  = (int) substr($zeile, strlen("<repValueFunction>"));
            if (strpos($zeile,"<repValueFunctionValue>") === 0) $var->value  = substr($zeile, strlen("<repValueFunctionValue>"));
            if (strpos($zeile,"<repValueFunctionAbSpalte>") === 0) $var->abSpalte  = (int) substr($zeile, strlen("<repValueFunctionAbSpalte>"));
            if (strpos($zeile,"<repValueFunctionNachSpalten>") === 0) $var->nachSpalten  = (int) substr($zeile, strlen("<repValueFunctionNachSpalten>"));
            
            
            if ($zeile == "</repValue>") {
                $query->repValues->put($var);
                $var = null;
            }

            if (strpos($zeile,"<repValueCalcBase>") === 0) $var->base  =  substr($zeile, strlen("<repValueCalcBase>"));
            
            
            
            if (strpos($zeile,"<repFilter>") === 0) {
                $name = substr($zeile, strlen("<repFilter>"));
                if (substr($name,0,1) == '#') $var = new WindowFilter($name);
                else $var = new RepFilter($name);
            }
            if (strpos($zeile,"<repFilterVon>") === 0) $var->fs_von  = substr($zeile, strlen("<repFilterVon>"));
            if (strpos($zeile,"<repFilterBis>") === 0) $var->fs_bis  = substr($zeile, strlen("<repFilterBis>"));
            if (strpos($zeile,"<repFilterAbSpalte>") === 0) $var->abSpalte  = substr($zeile, strlen("<repFilterAbSpalte>"));
            if (strpos($zeile,"<repFilterInTitelZeile>") === 0) $var->inTitelZeile  = substr($zeile, strlen("<repFilterInTitelZeile>"));
            if (strpos($zeile,"<repFilterInTitelMitLabel>") === 0) $var->inTitelMitLabel  = true;
            if (strpos($zeile,"<repFilterSelectorImOutput>") === 0) $var->selectorImOutput  = true;
            if (strpos($zeile,"<repFilterReportCopyFilter>") === 0) $var->reportCopyFilter  = true;
            if (strpos($zeile,"<repFilterDoNotTake>") === 0) $var->doNotTake  = true;
            if (strpos($zeile,"<repFilterListe>") === 0) {
                $var->fs_list = array();
                if ($zeile == '<repFilterListe>ausschlussListe') $var->ausschlussListe = true;
            }
            if (strpos($zeile,"<repFilterListElement>") === 0) $var->fs_list[] = substr($zeile, strlen("<repFilterListElement>"));                
            if ($zeile == "</repFilterListe>") ;                
            if ($zeile == "</repFilter>") {
                $query->repFilter->put($var);
                $var = null;
            }

            if (strpos($zeile,"<addFilter>") === 0) $var = new RepFilter(substr($zeile, strlen("<addFilter>")));
            if (strpos($zeile,"<addFilterVon>") === 0) $var->fs_von  = substr($zeile, strlen("<addFilterVon>"));
            if (strpos($zeile,"<addFilterBis>") === 0) $var->fs_bis  = substr($zeile, strlen("<addFilterBis>"));
            if (strpos($zeile,"<addFilterAbSpalte>") === 0) $var->abSpalte  = substr($zeile, strlen("<addFilterAbSpalte>"));
            if (strpos($zeile,"<addFilterInTitelZeile>") === 0) $var->inTitelZeile  = substr($zeile, strlen("<addFilterInTitelZeile>"));
            if (strpos($zeile,"<addFilterSelectorImOutput>") === 0) $var->selectorImOutput  = true;
            if (strpos($zeile,"<addFilterListe>") === 0) {
                $var->fs_list = array();
                if ($zeile == '<addFilterListe>ausschlussListe') $var->ausschlussListe = true;
            }
            if (strpos($zeile,"<addFilterListElement>") === 0) $var->fs_list[] = substr($zeile, strlen("<addFilterListElement>"));
            if ($zeile == "</addFilterListe>") ;
            if ($zeile == "</addFilter>") {
                $query->addFilter->put($var);
                $var = null;
            }
            
            if (strpos($zeile,"<repColumn>") === 0) $var = new RepColumn(substr($zeile, strlen("<repColumn>")));
            if (strpos($zeile,"<repColumnLabel>") === 0) $var->label  = substr($zeile, strlen("<repColumnLabel>"));
            if (strpos($zeile,"<repColumnValName>") === 0) $var->val_name  = substr($zeile, strlen("<repColumnValName>"));
            if (strpos($zeile,"<repColumnDispVal>") === 0) $var->displayOption  = substr($zeile, strlen("<repColumnDispVal>"));
            if (strpos($zeile,"<repColumnChartScale>") === 0) $var->skalierung  = 1 * substr($zeile, strlen("<repColumnChartScale>"));
            if (strpos($zeile,"<repColumnFilter>") === 0) $var->filter  = substr($zeile, strlen("<repColumnFilter>"));
            if (strpos($zeile,"<repColumnVon>") === 0) $var->fs_von  = substr($zeile, strlen("<repColumnVon>"));
            if (strpos($zeile,"<repColumnBis>") === 0) $var->fs_bis  = substr($zeile, strlen("<repColumnBis>"));
            if (strpos($zeile,"<repColumnLink>") === 0) $var->web_link  = substr($zeile, strlen("<repColumnLink>"));
            if (strpos($zeile,"<repColumnLinkTitle>") === 0) $var->web_title  = substr($zeile, strlen("<repColumnLinkTitle>"));
            if (strpos($zeile,"<repColumnLinkTarget>") === 0) $var->web_target  = substr($zeile, strlen("<repColumnLinkTarget>"));
            if ($zeile == "<repColumnKeineSummen>") $var->keineSummen = true;
            if ($zeile == "<repColumnDescending>") $var->sort = 3;
            if (strpos($zeile,"<repColumnSort>") === 0) $var->sort  = (int) substr($zeile, strlen("<repColumnSort>"));
            if ($zeile == "<repColumnCopyFilter>") $var->reportCopyFilter = true;
            if ($zeile == "<repColumnLinkInValues>") $var->reportLinkInValues = true;
            if (strpos($zeile,"<repColumnFunction>") === 0) $var->function  = (int) substr($zeile, strlen("<repColumnFunction>"));
            if (strpos($zeile,"<repColumnFunctionAbSpalte>") === 0) $var->abSpalte  = (int) substr($zeile, strlen("<repColumnFunctionAbSpalte>"));
            if (strpos($zeile,"<repColumnFunctionNachSpalten>") === 0) $var->nachSpalten  = (int) substr($zeile, strlen("<repColumnFunctionNachSpalten>"));
            
            if ($zeile == "</repColumn>") { 
                $query->repColumns->put($var);
                $var = null;
            }

            if (strpos($zeile,"<repTable>") === 0) 
                if (($zeile2 = fgets($datei)) !== false) 
                    if (strpos($zeile2,"<repTableClass>") === 0){
                        $zeile2 = trim($zeile2);
                        $aq = $query->addQueries->get(substr($zeile2, strlen("<repTableClass>")));
                        if ($aq != null) {
                            $var = new JoinedTable($aq);
                            $var->kennzeichen = substr($zeile, strlen("<repTable>"));
                        }
                        else {
                            $meldungen .=  'Fehler bei add repTable '.substr($zeile2, strlen("<repTableClass>")).' nicht geladen<br>';
                            $meldungen .=  'Dump addQueries:<br>';
                            for ($iaq = 0; $iaq < $query->addQueries->size(); $iaq++)
                                $meldungen .=  $query->addQueries->getPos($iaq)->getQuery()->class_table.'<br>';
                            $var = null;    
                        }
                }
            
            if ($var != null){
                if (strpos($zeile,"<repTablePrefix>") === 0) $var->prefix  = substr($zeile, strlen("<repTablePrefix>"));
                if (strpos($zeile,"<repTableJoinType>") === 0) $var->joinType  =  1* substr($zeile, strlen("<repTableJoinType>"));
                
                if (strpos($zeile,"<repTableDimHistOption>") === 0) {
                    $values  = explode('.', substr($zeile, strlen("<repTableDimHistOption>")));
                    $var->dimHistoryOption[1*$values[0]] =  1* $values[1];
                }
                if (strpos($zeile,"<repTableDimHistDate>") === 0) {
                    $values  = explode('.', substr($zeile, strlen("<repTableDimHistDate>")));
                    $var->dimHistoryDate[1*$values[0]] = $values[1];
                }
            }
            if ($zeile == "</repTable>") {
                if ($var != null) $query->repTables->put($var);
                $var = null;
            }

            if (strpos($zeile,"<repReport>") === 0) $var = new RepReport(substr($zeile, strlen("<repReport>")));
            if (strpos($zeile,"<repReportKommentar>") === 0) $var->kommentar  = substr($zeile, strlen("<repReportKommentar>"));
            if (strpos($zeile,"<repReportCopyFilter>") === 0) $var->copyFilter  = true;
            if ($zeile == "</repReport>") {
                $query->repReports->put($var);
                $var = null;
            }
            
            
            if (strpos($zeile,"<repWerteBasis>") === 0) $query->repWerteBasis = substr($zeile, strlen("<repWerteBasis>"));
            if (strpos($zeile,"<repWerteAuswahlTitel>") === 0) $query->repWerteAuswahlTitel = (int) substr($zeile, strlen("<repWerteAuswahlTitel>"));
            if (strpos($zeile,"<repWerteAuswahlLabel>") === 0) $query->repWerteAuswahlLabel = true;
            if (strpos($zeile,"<repWerteAuswahlSelector>") === 0) $query->repWerteAuswahlSelector = true;
            
            if ($zeile == "<kommentar>"){
                $query->kommentar = '';
                while ((($zeile2 = fgets($datei)) !== false) && $zeile2 != "</kommentar>\n")
                    $query->kommentar .=  $zeile2;
                $query->kommentar = trim($query->kommentar);
            }
            
            if (strpos($zeile,"<kommentarTranslated>") === 0) {
                $lang = substr($zeile,strlen("<kommentarTranslated>"),2);
                $query->reportImported = true;
                if ($query->description_imported == null) $query->description_imported = array();
                $query->description_imported[$lang] = "";
                while (($zeile = fgets($datei)) !== false && (strpos($zeile, "</kommentarTranslated>") === false)) {
                    $query->description_imported[$lang].=$zeile;
                }
                //        $query->description_imported[$lang] = trim($query->description_imported[$lang]);
                error_log('Importiere Description '.$lang);
                error_log('>'.$query->description_imported[$lang].'<');
            }
            
            if ($zeile == "<hints>"){
                $query->report_hints = '';
                while ((($zeile2 = fgets($datei)) !== false) && $zeile2 != "</hints>\n")
                    $query->report_hints .=  $zeile2;
                    $query->report_hints = trim($query->report_hints);
            }
            
            if (strpos($zeile,"<hintsTranslated>") === 0) {
                $lang = substr($zeile,strlen("<hintsTranslated>"),2);
                $query->reportImported = true;
                if ($query->hints_imported == null) $query->hints_imported = array();
                $query->hints_imported[$lang] = "";
                while (($zeile = fgets($datei)) !== false && (strpos($zeile, "</hintsTranslated>") === false)) {
                    $query->hints_imported[$lang].=$zeile;
                }
                //        $query->description_imported[$lang] = trim($query->description_imported[$lang]);
                error_log('Importiere Techn. Hinweise '.$lang);
                error_log('>'.$query->hints_imported[$lang].'<');
            }
            
            
            if ($zeile == "</WS-Report>") $fertig = true;
            if ($zeile == "</WS-Report") $fertig = true;
        }
    }
}

        if ($fertig){
            $meldungen .= "Die Report-Definition ".$query->title
                ."<br>wurde aus der Datei ".$importFileName." eingelesen.<br>\n"
                ."Hinweis: Die Definition wurde noch nicht gespeichert.<br>\n" ;
           if ($query->addFilter->size() > 0)
               $meldungen .= "ACHTUNG: Bitte Zusatzfilter prüfen.\n";
        }
        else {
            if ($query == null && $start)
                $meldungen .= "Das Einlesen der Report-Definition "                    
                    ."<br>aus der Datei ".$importFileName." wurde abgebrochen.<br>\n";
            else
                if ($start) $meldungen .= "Die Report-Definition ".$query->title                
                    ."<br>wurde aus der Datei ".$importFileName." eingelesen.<br>\n";
            else $meldungen .=  "FEHLER: Die Datei ".$importFileName." enthält keine gültige Report-Definition.<br>\n";
        }
$query->titleModified = true;        
}