/**
 * Projekt: WS-Reporter
 *          Benutzerverwaltung und Rollenverwaltung
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    14.3.2022
 * 
 * Rollen-Verwaltung läuft leider(!) noch immer über submits
 */

function zuordnen(user){
	form = document.getElementById('form');
	form.action.value = 'zuordnen';
	form.userID.value=user;
	form.submit();
}	

function setStartSeite(user,startSeite){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('action','setStartSeite');
	formData.append('userID',user);
	formData.append('startSeite',startSeite);
	request.open("POST","./setUserAttribute.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set Startseite\n"+request.responseText);
			   } else {
					alert("setStartSeite\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}

function setRolle(user,rolle){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('action','setRolle');
	formData.append('userID',user);
	formData.append('rolle',rolle);
	request.open("POST","./setUserAttribute.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
						console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set Rolle\n"+request.responseText);
			   } else {
					alert("setRolle\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}


function setLesen(datenquelle,user,checked){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('userID',user);
	formData.append('datenquelle',datenquelle);
	if (checked) formData.append('action','setLesen');
	else  formData.append('action','unsetLesen');
	request.open("POST","./setUserAttribute.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set/Unset Lesen\n"+request.responseText);
			   } else {
					alert("set/unsetLesen\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}

function setAdmin(datenquelle,user,checked){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('userID',user);
	formData.append('datenquelle',datenquelle);
	if (checked) formData.append('action','setAdmin');
	else  formData.append('action','unsetAdmin');
	request.open("POST","./setUserAttribute.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set/Unset Admin\n"+request.responseText);
			   } else {
					alert("set/unsetAdmin\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}

function setFilter(datenquelle,user,attrib, value){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('userID',user);
	formData.append('value',value);
	formData.append('attrib',attrib);
	formData.append('datenquelle',datenquelle);
	formData.append('action','setFilter');
	
	request.open("POST","./setUserAttribute.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set/Unset Filter\n"+request.responseText);
			   } else {
					alert("set/unsetFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}

function setUserFilter(user,attrib, value){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('userID',user);
	formData.append('value',value);
	formData.append('attrib',attrib);
	formData.append('action','setUserFilter');
	
	request.open("POST","./setUserAttribute.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set/Unset Filter\n"+request.responseText);
			   } else {
					alert("set/unsetFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}

function showFilter(user,table,filter){	
	f=document.getElementById(filter).value;
  	win = open("./editUserShowFilter.php?userName="+encodeURIComponent(user)
            +'&table='+encodeURIComponent(table)+'&filter='+encodeURIComponent(f),
  			"WSRFilter",
  			"width=900,height=700,screenX=500,screenY=300,scrollbars=yes");
}

/**
 * Funktionen für die Rollenverwaltung
 */

function delRolle(rolle){
	var form = document.getElementById('form');
	form.rolle.value = rolle;
	form.action.value ='delRolle';
	form.submit();
	
}
function selRolle(rolle){
	var form = document.getElementById('form');
	form.rolle.value = rolle;
	form.action.value ='';
	form.submit();
}

function neueRolle(inpRolle){
	var rolle = inpRolle.value;
	inpRolle.value = '';
	var form = document.getElementById('form');
	form.rolle.value = rolle;
	form.action.value = 'neueRolle';
	form.submit();	
}

function selQuelle(quelle){
	var form = document.getElementById('form');
	form.quelle.value = quelle;
	form.action.value ='';
	form.submit();
}


function selReport(report){
	var form = document.getElementById('form');
	form.report.value = report;
	form.action.value = 'selReport';
	form.submit();	
} 

function delReport(report){
	var form = document.getElementById('form');
	form.report.value = report;
	form.action.value = 'delReport';
	form.submit();	
	
} 
function upReport(report){
	var form = document.getElementById('form');
	form.report.value = report;
	form.action.value = 'upReport';
	form.submit();	
	
} 
function downReport(report){
	var form = document.getElementById('form');
	form.report.value = report;
	form.action.value = 'downReport';
	form.submit();	
	
} 
function outputReport(report){
	var form = document.getElementById('outputForm');
	form.report.value=report;
	form.submit();
} 



/**
 * Drag and drop
 */

var oldColor = null;
var vonWo = null;
var vonPos = null;
function dragEnter(o){
}

function dragLeave(o){
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
}

function dragStart(event,wo,pos){
	vonWo = wo;
	vonPos = pos;
	event.dataTransfer.dropEffect = 'move';
 	event.effectAllowed = "move";
}

function drop(event,wo,pos,o){
	o = event.target;	
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
	moveTo(wo,vonPos,pos);			
}

function dragOver(event,wo,o){
	if (vonWo == wo) {
		if (! o.hasAttribute('backup_bColor')) {
			if (o.style.backgroundColor != null) o.setAttribute('backup_bColor', o.style.backgroundColor);
			else o.setAttribute('backup_bColor', '');
		}
		o.style.backgroundColor = '#aaff88';
		event.preventDefault();	
	}	
}


function rollenDrop(event,wo,pos,o){
	o = event.target;	
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
	moveToRollen(vonPos,pos);			
}

function moveToRollen(report,ziel){
	var form = document.getElementById('form');
	form.report.value = report;
	form.action.value = 'moveReport';
	form.ziel.value = ziel;
	form.submit();	

	
}			

