/**
 * Projekt: WS-Reporter
 *          JavaScript-Funktionen für Übersetzungen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    17.6.2022
 *
 * Parameter:
 *      action: 
 *      langugage: Sprache aus der Spezifikation
 *      tLanguage: Sprache, in die übersetzt wird
 *      type: qLanguageType: Typ der Übersetzung
 *      text: Text, der übersetzt wird
 *      translation: Übersetzung
 */

/* globale Variablen */
var language = 'de';

function closeEditor(){
	document.getElementById("Editor").style.display = "none";
}


function enter(inputObject,type){	
	var id = inputObject.id;
	var sId = id.substring(0,id.length-2);
	var textId = sId+language;
//	var typeId = sId+type;
	var tLanguage = id.substring(id.length-2);

	var formData = new FormData();
	formData.append('action','enter');
	formData.append('language',language);
	formData.append('tLanguage',tLanguage);
	formData.append('type',type);
	formData.append('text',document.getElementById(textId).value);
	formData.append('translation',inputObject.value);
	console.log(formData);
	var request = new XMLHttpRequest();
	request.open("POST","./translate.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					console.log(request.responseText);
					var r = document.getElementById('R'+id.substring(1));
					console.log('R'+id.substring(1)+' ist '+r);
					if (r != null) r.innerText = 'eingetragen';	
				} else if (request.status == 425) {						
				  	alert("Fehler bei Übersetzung\n"+request.responseText);
				} else if (request.status == 400) {						
				  	alert("Fehler:\n"+request.responseText);
			   } else {
					alert("enter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);		
	console.log('S>'+document.getElementById(textId).value+'<');
	console.log('S>'+inputObject.value+'<');
				
}

function setQText(inputObject,table, type){	
//	var typeId = sId+type;
	var language = inputObject.lang;

	var formData = new FormData();
	formData.append('action','setQText');
	formData.append('language',language);
	formData.append('type',type);
	formData.append('table_name',table);
	formData.append('text',inputObject.value);
	console.log(formData);
	var request = new XMLHttpRequest();
	request.open("POST","./translate.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei enter Query Description\n"+request.responseText);
				} else if (request.status == 400) {						
				  	alert("Fehler:\n"+request.responseText);
			   } else {
					alert("enter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);		
	console.log('S>'+inputObject.value+'<');
				
}

function setRText(inputObject,reportID, type){	
//	var typeId = sId+type;
	var id = inputObject.id;
	var language = id.substring(id.length-2);

	var formData = new FormData();
	formData.append('action','setRText');
	formData.append('language',language);
	formData.append('type',type);
	formData.append('reportID',reportID);
	formData.append('text',inputObject.value);
	console.log(formData);
	var request = new XMLHttpRequest();
	request.open("POST","./translate.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei enter Report Text\n"+request.responseText);
				} else if (request.status == 400) {						
				  	alert("Fehler:\n"+request.responseText);
			   } else {
					alert("enter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);		
	console.log('S>'+inputObject.value+'<');
				
}


function showVarsById(id){
	var t = document.getElementById(id);
	if (t != null) showVars(t.value);
	else console.log('FEHLER: ID='+id+' nicht gefunden');
}


function showTranslationById(id){
	var t = document.getElementById(id);
	if (t != null && t.lang != null) showTranslation(t.value,t.lang);
	else console.log('FEHLER: ID='+id+' nicht gefunden oder ohne lang-Attribut');
}



function showVars(text){
	document.getElementById('VerwText').innerText = text;
	var formData = new FormData();
	formData.append('text',text);
	console.log(formData);
	var request = new XMLHttpRequest();
	request.open("POST","./translateQSearch.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
console.log(request.responseText);				
  	    var tabelle = document.getElementById("Tabelle");
var		ziel = document.getElementById("Editor");
  	    ziel.style.display="block";
		ziel.style.zIndex = '2';
  document.getElementById("VerwAnzeige").innerHTML = request.responseText;					
					}else{
				alert("FEHLER:\n"+
					request.responseText);
						
					}
					});
	request.send(formData);								
}

function showTranslation(text,lang){
	document.getElementById('VerwText').innerText = text;

	var formData = new FormData();
	formData.append('text',text);
	formData.append('language',lang);
	console.log(formData);
	var request = new XMLHttpRequest();
	request.open("POST","./translateTSearch.php");
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				console.log(request.responseText);
	  	    var tabelle = document.getElementById("Tabelle");
document.getElementById("Tabelle").style.zIndex = '1';
var		ziel = document.getElementById("Editor");
  	    ziel.style.display="block";
  	    ziel.style.position="absolute";
//  	    ziel.style.top="50 em";
//  	    ziel.style.right="0";
		ziel.style.zIndex = '2';
  document.getElementById("VerwAnzeige").innerHTML = request.responseText;					
			}else			   
				if (request.status == 201) {
					alert(request.responseText);
			}else{
				alert("FEHLER:\n"+request.responseText);
			}
	});
	request.send(formData);								
	
}

function deleteTranslationById(id,language){
	var t = document.getElementById(id);
	if (t != null && t.lang != null) {
		if (window.confirm("Soll der Eintrag\n"+t.value+"\nwirklich gelöscht werden?")){
			var formData = new FormData();
			
			formData.append('action','delete');
			formData.append('type',0);
			formData.append('text',t.value);
			formData.append('language',language);
			console.log(formData);
			var request = new XMLHttpRequest();
			request.open("POST","./translateTDelete.php");
				request.addEventListener('load', function(event) {
			    if (request.status == 200) {
				    var p = t.parentElement;
					while (p.tagName != 'TR') p = p.parentElement;
					pr = p;
					do {
						 p = p.previousElementSibling;
					} while (! p.firstElementChild.classList.contains('WSFHeader')) ;
					p.firstElementChild.WSFrows --;
					p.firstElementChild.rowSpan --;
					pr.remove();
				}else{
					alert("FEHLER:\n"+
					request.responseText);
				}
					return false;
				}
			);
			request.send(formData);								
		}
	}
	else console.log('FEHLER: ID='+id+' nicht gefunden oder ohne lang-Attribut');
}

function deleteTranslationTodel(){
	var t = document.getElementById('todel');
	
	if (t != null && t.innerText > '') {
		var text = t.innerText;
		if (window.confirm("Soll der Eintrag\n"+text+"\nwirklich gelöscht werden?")){
			var formData = new FormData();
			
			formData.append('action','delete');
			formData.append('type',0);
			formData.append('text',text);
			formData.append('language','de');
			console.log(formData);
			var request = new XMLHttpRequest();
			request.open("POST","./translateTDelete.php");
				request.addEventListener('load', function(event) {
			    if (request.status == 200) {
				    alert('Eintrag gelöscht');
				}else{
					alert("FEHLER:\n"+
					request.responseText);
				}
					return false;
				}
			);
			request.send(formData);								
		}
	}
	else alert('Ungültiger Lösch-Versuch');
		
}



function ignoreNewImport(id){
//	var id = 'R'+id.substring(1);
	var r = document.getElementById('R'+id.substring(1));
	console.log('R'+id.substring(1)+' ist '+r);
	if (r != null) r.innerText = 'Import ignoriert';		
}
function enterNewImport(id,type){
//	var id = 'R'+id.substring(1);
	var d = document.getElementById(id);
	if (d != null) enter(d,type);
	else alert('FEHLER bei enterNewImport mit '+id);
			
}
