<?php
/**
 * Projekt: WS-Reporter
 *          Übersetzungen eintragen oder löschen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    5.8.2022
 *
 * Parameter:
 *      action: 
 *      langugage: Sprache aus der Spezifikation
 *      tLanguage: Sprache, in die übersetzt wird
 *      type: qLanguageType: Typ der Übersetzung
 *      text: Text, der übersetzt wird
 *      translation: Übersetzung
 *      
 * Es werden grundsätzlich decodierte Texte gespeichert, mit < statt &lt; usw.
 * Führende und folgende Zeilenvorschübe und Blanks werden gelöscht!    
 * CR (\r) werden entfernt.
 * 
 * Fehler-Code: 425
 */


/* Zuerst language und tLanguage prüfen */

require_once './includes/classes.inc';
 



if (!array_key_exists('action', $_REQUEST)){
    http_response_code(400);
    echo 'Parameter action fehlt.';
    die();
}

switch ($_REQUEST['action']) {
    case 'enter':
        if (array_key_exists('tLanguage', $_REQUEST)){
            switch ($_REQUEST['tLanguage']) {
                case 'en':
                    $tLanguage = 'en';
                    break;
                case 'fr':
                    $tLanguage = 'fr';
                    break;
                    
                default:
                    http_response_code(400);
                    echo 'Parameter tLanguage '.$_REQUEST['tLanguage'].'ist ungültig.';
                    die();
                    break;
            }
            
        }else{
            http_response_code(400);
            echo 'Parameter tLanguage fehlt.';
            die();
        }
        if (!array_key_exists('type', $_REQUEST)){
            http_response_code(400);
            echo 'Parameter type fehlt.';
            die();
        }
        if (!array_key_exists('text', $_REQUEST)){
            http_response_code(400);
            echo 'Parameter text fehlt.';
            die();
        }
        $text = html_entity_decode($_REQUEST['text']);
        $text = trim(str_replace("\r", '',$text));
        if (!array_key_exists('translation', $_REQUEST)){
            http_response_code(400);
            echo 'Parameter translation fehlt.';
            die();
        }
        $translation = html_entity_decode($_REQUEST['translation']);
        $translation = trim(str_replace("\r", '',$translation));
        $sql = new SqlAbfrage('WSR');
        $sql->sql = 'update wsrTranslations set';
        $sql->addKlausel($tLanguage.' =', $translation);
        $sql->addSel('de = ',$text);
        if (!$sql->execute()) {
            http_response_code(425);
            if ($sql->errorInfo()[0] == 23000){
                $sql = new SqlAbfrage('WSR');
                $sql->sql = 'select de from wsrTranslations';
                $sql->addSel($tLanguage.' =', $translation);
                $stmt = $sql->execute();
                if (!$stmt) {
                    echo "FEHLER 2 bei Duplicate Entry:\n:".$sql->errorInfo()[2];
                    die();
                }
                $z = $stmt->fetchObject();
                echo $translation,"\n ist Übersetzung von\n".$z->de;
                die();                
            }
            echo $sql->errorInfo()[2];
            die();
        }        
    ;
    break;
    case 'delete':
        if (!array_key_exists('text', $_REQUEST)){
            http_response_code(400);
            echo 'Parameter text fehlt.';
            die();
        }
        $text = html_entity_decode($_REQUEST['text']);
        $text = trim(str_replace("\r", '',$text));
        $sql = new SqlAbfrage('WSR');
        $sql->sql = 'delete from wsrTranslations ';
        $sql->addSel('de = ',$text);
        if (!$sql->execute()) {
            http_response_code(425);
            echo $sql->errorInfo()[2];
            die();
        }
    break;    
    default:
        http_response_code(400);
        echo 'Parameter action '.$_REQUEST['action'].'ist ungültig.';
        die();
        break;
}

